//Known issues
//Creates 1060 datablocks.
//Bricks placed on top of modTer bricks are placed on top of static shapes
//	These bricks are labeled as "baseplates"
//		So the ground can be removed from underneath them, and the bricks will not collapse automatically.

function ModTerCollision()
{
	echo("Making ModTer bCol");
	%file = findFirstFile("Add-Ons/Server_ModTerCollision/shapes/*.dts");
	while(isFile(%file))
	{
		if(filePath(%file)$="Add-Ons/Server_ModTerCollision/shapes/secondary")//I didn't realize it would search through subfolders.  This eliminates a problem, but the real solution is to restructure the folder system.
		{
			%file = findNextFile("Add-Ons/Server_ModTerCollision/shapes/*.dts");
			continue;
		}

		%db = nametoid("brick"@fileBase(%file)@"Data");
		if(isObject(%db))
		{
			eval("datablock staticShapeData(bCol"@fileBase(%file)@"A0Data){shapeFile = \""@%file@"\";};");
			%dbcount++;
			%db.bColData[0] = "bCol"@fileBase(%file)@"A0Data";
			%db.bColData[1] = "bCol"@fileBase(%file)@"A0Data";
			%db.bColData[2] = "bCol"@fileBase(%file)@"A0Data";
			%db.bColData[3] = "bCol"@fileBase(%file)@"A0Data";
			if(isFile(%anglefile = filePath(%file)@"/rotations/"@fileBase(%file)@"A1"@fileExt(%file)))
			{
				eval("datablock staticShapeData(bCol"@fileBase(%anglefile)@"Data){shapeFile = \""@%anglefile@"\";};");
				%dbcount++;
				%db.bColData[1] = "bCol"@fileBase(%anglefile)@"Data";
				%db.bColData[3] = "bCol"@fileBase(%anglefile)@"Data";
			}
			if(isFile(%anglefile = filePath(%file)@"/rotations/"@fileBase(%file)@"A2"@fileExt(%file)))
			{
				eval("datablock staticShapeData(bCol"@fileBase(%anglefile)@"Data){shapeFile = \""@%anglefile@"\";};");
				%dbcount++;
				%db.bColData[2] = "bCol"@fileBase(%anglefile)@"Data";
			}
			if(isFile(%anglefile = filePath(%file)@"/rotations/"@fileBase(%file)@"A3"@fileExt(%file)))
			{
				eval("datablock staticShapeData(bCol"@fileBase(%anglefile)@"Data){shapeFile = \""@%anglefile@"\";};");
				%dbcount++;
				%db.bColData[3] = "bCol"@fileBase(%anglefile)@"Data";
			}


			//WTF is this secondary bullshit?
			//brick[n]CornerD[n]Data is a concave shape.
			//If I split it into two shapes, i can make them convex, which gives it proper collision.
			if(isFile(%filesecondary = filePath(%file)@"/secondary/"@fileName(%file)))
			{
				eval("datablock staticShapeData(bCol"@fileBase(%filesecondary)@"A0SecData){shapeFile = \""@%filesecondary@"\";};");
				%dbcount++;
				%db.bColDataSec[0] = "bCol"@fileBase(%filesecondary)@"A0SecData";
				%db.bColDataSec[1] = "bCol"@fileBase(%filesecondary)@"A0SecData";
				%db.bColDataSec[2] = "bCol"@fileBase(%filesecondary)@"A0SecData";
				%db.bColDataSec[3] = "bCol"@fileBase(%filesecondary)@"A0SecData";
				if(isFile(%anglefile = filePath(%filesecondary)@"/rotations/"@fileBase(%filesecondary)@"A1"@fileExt(%filesecondary)))
				{
					eval("datablock staticShapeData(bCol"@fileBase(%anglefile)@"SecData){shapeFile = \""@%anglefile@"\";};");
					%dbcount++;
					%db.bColDataSec[1] = "bCol"@fileBase(%anglefile)@"SecData";
					%db.bColDataSec[3] = "bCol"@fileBase(%anglefile)@"SecData";
				}
				if(isFile(%anglefile = filePath(%filesecondary)@"/rotations/"@fileBase(%filesecondary)@"A2"@fileExt(%filesecondary)))
				{
					eval("datablock staticShapeData(bCol"@fileBase(%anglefile)@"SecData){shapeFile = \""@%anglefile@"\";};");
					%dbcount++;
					%db.bColDataSec[2] = "bCol"@fileBase(%anglefile)@"SecData";
				}
				if(isFile(%anglefile = filePath(%filesecondary)@"/rotations/"@fileBase(%filesecondary)@"A3"@fileExt(%filesecondary)))
				{
					eval("datablock staticShapeData(bCol"@fileBase(%anglefile)@"SecData){shapeFile = \""@%anglefile@"\";};");
					%dbcount++;
					%db.bColDataSec[3] = "bCol"@fileBase(%anglefile)@"SecData";
				}
			}
		}
		%file = findNextFile("Add-Ons/Server_ModTerCollision/shapes/*.dts");
	}
	echo("Created "@%dbcount@" additional datablocks.");
}

if(isPackage(ModTerColPackage))
	deactivatepackage(ModTerColPackage);

function fxDTSBrick::bColCheck(%this)
{
	if(isObject(%this.bColShape))
	{
		if(!%this.isRaycasting()||!%this.isColliding())
		{
			%this.bColShape.setHidden(1);
		}
		else
		{
			%this.bColShape.setHidden(0);
		}
		if(isObject(%this.bColShapeSec))
		{
			if(!%this.isRaycasting()||!%this.isColliding())
			{
				%this.bColShapeSec.setHidden(1);
			}
			else
			{
				%this.bColShapeSec.setHidden(0);
			}
		}
	}
}

package ModTerColPackage
{
	function verifyBrickUINames()
	{
		ModTerCollision();
		Parent::verifyBrickUINames();
	}
	function onMissionLoaded()
	{
		if(!isObject(bColGroup))
		{
			%obj = new SimGroup("bColGroup");
			MissionCleanup.add(%obj);
		}
		Parent::onMissionLoaded();
	}
	function fxDTSBrick::setColliding(%this,%bool)
	{
		Parent::setColliding(%this,%bool);
		%this.bColCheck();
	}
	function fxDTSBrick::setRayCasting(%this,%bool)
	{
		Parent::setRayCasting(%this,%bool);
		%this.bColCheck();
	}
	function fxDTSBrick::onDeath(%this)
	{
		Parent::onDeath(%this);
		%this.bColCheck();
	}
	function fxDTSBrick::onFakeDeath(%this)
	{
		Parent::onFakeDeath(%this);
		%this.bColCheck();
	}
	function fxDTSBrick::onRespawn(%this)
	{
		Parent::onRespawn(%this);
		%this.bColCheck();
	}
	function fxDTSBrick::onBlownUp(%this)
	{
		Parent::onBlownUp(%this);
		%this.bColCheck();
	}

	//Uncomment these if you have trouble with projectiles hitting the collision shape.
	//	That shouldn't occur, but I left it here for just-in-casies
	//	It still won't fix onplayertouch or onactivate.  But the tools and weapons will work on the brick again.
	//function ProjectileData::onCollision(%this, %proj, %col, %fade, %pos, %normal, %velocity)
	//{
	//	if(isObject(%col.bColBrick))
	//		%col = %col.bColBrick;
	//	Parent::onCollision(%this, %proj, %col, %fade, %pos, %normal, %velocity)
	//}
	//function ShapeBaseImageData::onHitObject(%this, %player, %c, %col, %pos, %normal)
	//{
	//	if(isObject(%col.bColBrick))
	//		%col = %col.bColBrick;
	//	Parent::onHitObject(%this, %player, %c, %col, %pos, %normal);
	//}
	function fxDTSBrick::onPlant(%this)
	{
		%db = %this.getDatablock();
		if(isObject(%db))
		{
			if(isObject(%db.bColData[%this.angleid]))
			{
				%this.bColShape = new StaticShape()
				{
					position = %this.position;
					rotation = "1 0 0 0";
					scale = "0.5 0.5 0.5";
					dataBlock = %db.bColData[%this.angleid];
					cansetIFLS = "0";
				};
				bColGroup.add(%this.bColShape);
				%this.bColShape.bColBrick = %this;

				if(isObject(%db.bColDataSec[%this.angleid]))
				{
					%this.bColShapeSec = new StaticShape()
					{
						position = %this.position;
						rotation = "1 0 0 0";
						scale = "0.5 0.5 0.5";
						dataBlock = %db.bColDataSec[%this.angleid];
						cansetIFLS = "0";
					};
					bColGroup.add(%this.bColShapeSec);
					%this.bColShapeSec.bColBrick = %this;
				}

				%this.bColCheck();
			}
		}
		Parent::onPlant(%this);
	}
	function fxDTSBrick::onLoadPlant(%this)
	{
		%db = %this.getDatablock();
		if(isObject(%db))
		{
			if(isObject(%db.bColData[%this.angleid]))
			{
				%this.bColShape = new StaticShape()
				{
					position = %this.position;
					rotation = "1 0 0 0";
					scale = "0.5 0.5 0.5";
					dataBlock = %db.bColData[%this.angleid];
					cansetIFLS = "0";
				};
				bColGroup.add(%this.bColShape);
				%this.bColShape.bColBrick = %this;

				if(isObject(%db.bColDataSec[%this.angleid]))
				{
					%this.bColShapeSec = new StaticShape()
					{
						position = %this.position;
						rotation = "1 0 0 0";
						scale = "0.5 0.5 0.5";
						dataBlock = %db.bColDataSec[%this.angleid];
						cansetIFLS = "0";
					};
					bColGroup.add(%this.bColShapeSec);
					%this.bColShapeSec.bColBrick = %this;
				}
				
				%this.bColCheck();
			}
		}
		Parent::onLoadPlant(%this);
	}
	function fxDTSBrick::onRemove(%this)
	{
		if(isObject(%this.bColShape))
		{
			%this.bColShape.delete();
			if(isObject(%this.bColShapeSec))
			{
				%this.bColShapeSec.delete();
			}
		}
		Parent::onRemove(%this);
	}
};
activatepackage(ModTerColPackage);